<?php
namespace GCS\Custom;

if ( ! function_exists( 'add_action' ) ) :
	exit(0);
endif;

class Setting
{
	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BACKGROUND_COLOR;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BACKGROUND_COLOR_HOVER;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BORDER_COLOR;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BORDER_COLOR_HOVER;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BORDER_RADIUS;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BORDER_STYLE;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_BORDER_WIDTH;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_SHADOW;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $BTN_FONT_SIZE;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_FONT_STYLE;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_FONT_WEIGHT;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_PADDING;

	/**
	 *
	 * @since 1.0
	 * @var string
	 */
	private $BTN_POSITION;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_TEXT_COLOR;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_TEXT_COLOR_HOVER;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $BTN_TEXT_TRANSFORM;

	/**
	 *
	 * @since 1.0
	 * @var string
	 */
	private $BTN_WIDTH;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $LABEL_FONT_SIZE;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $LABEL_TEXT_TRANSFORM;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $TEXT_TEXT_TRANSFORM;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $INPUT_BORDER_STYLE;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $INPUT_SHADOW;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $border;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $checked;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $error;

	/**
	 *
	 * @since 1.0
	 * @var string
	 */
	 private $focus;

	/**
	 *
	 * @since 1.0
	 * @var int
	 */
	private $input;

	/**
	 *
	 * @since 1.0
	 * @var int
	 */
	private $input_error;

	/**
	 *
	 * @since 1.0
	 * @var string
	 */
	 private $label;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $placeholder;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $text;

	/**
	 *
	 * @since 1.0
	 * @var string
	 */
	 private $success;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $border_size;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $input_size;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $textarea_size;

	/**
	*
	* @since 1.0
	* @var string
	*/
	private $border_radius;

	/**
	*
	* @since 1.0
	* @var int
	*/
	private $font_size;

	/**
	 * Nonces
	 *
	 * @since 1.0
	 * @var string
	 */
	const NONCE_GENERAL_ACTION = 'gcs-setting-general-action';

	const NONCE_GENERAL_NAME   = 'gcs-setting-general-name';

	/**
	 * Options
	 *
	 * @since 1.0
	 * @var string
	 */

	const OPTION_BTN_BACKGROUND_COLOR = 'gfcs-btn-background-color';

	const OPTION_BTN_BACKGROUND_COLOR_HOVER = 'gfcs-btn-background-color-hover';

	const OPTION_BTN_BORDER_COLOR = 'gfcs-btn-border-color';

	const OPTION_BTN_BORDER_COLOR_HOVER = 'gfcs-btn-border-color-hover';

	const OPTION_BTN_BORDER_RADIUS = 'gfcs-btn-border-radius';

	const OPTION_BTN_BORDER_STYLE = 'gfcs-btn-border-style';

	const OPTION_BTN_BORDER_WIDTH = 'gfcs-btn-border-width';

	const OPTION_BTN_SHADOW = 'gfcs-btn-shadow';

	const OPTION_BTN_FONT_SIZE = 'gfcs-btn-font-size';

	const OPTION_BTN_FONT_STYLE = 'gfcs-btn-font-style';

	const OPTION_BTN_FONT_WEIGHT = 'gfcs-btn-font-weight';

	const OPTION_BTN_PADDING = 'gfcs-btn-padding';

	const OPTION_BTN_POSITION = 'gfcs-btn-position';

	const OPTION_BTN_TEXT_COLOR = 'gfcs-btn-text-color';

	const OPTION_BTN_TEXT_COLOR_HOVER = 'gfcs-btn-text-color-hover';

	const OPTION_BTN_TEXT_TRANSFORM = 'gfcs-btn-text-transform';

	const OPTION_BTN_WIDTH = 'gfcs-btn-width';

	const OPTION_LABEL_FONT_SIZE = 'gfcs-label-font-size';

	const OPTION_LABEL_TEXT_TRANSFORM = 'gfcs-label-text-transform';

	const OPTION_TEXT_TEXT_TRANSFORM = 'gfcs-text-text-transform';

	const OPTION_INPUT_BORDER_STYLE = 'gfcs-input-border-style';

	const OPTION_INPUT_SHADOW = 'gfcs-input-shadow';

	const OPTION_COLOR_BORDER = 'gcs-field-border';

	const OPTION_COLOR_CHECKED = 'gcs-field-checked';

	const OPTION_COLOR_ERROR = 'gcs-field-error';

	const OPTION_COLOR_FOCUS = 'gcs-field-focus';

	const OPTION_COLOR_INPUT = 'gcs-field-input';

	const OPTION_COLOR_INPUT_ERROR = 'gcs-field-input-error';

	const OPTION_COLOR_LABEL = 'gcs-field-label';

	const OPTION_COLOR_PLACEHOLDER = 'gcs-field-placeholder';

	const OPTION_COLOR_TEXT = 'gcs-field-text';

	const OPTION_COLOR_SUCCESS = 'gcs-field-success';

	const OPTION_BORDER_SIZE = 'gcs-field-border-size';

	const OPTION_INPUT_SIZE = 'gcs-field-input-size';

	const OPTION_TEXTAREA_SIZE = 'gcs-field-textarea-size';

	const OPTION_BORDER_RADIUS = 'gcs-field-border-radius';

	const OPTION_FONT_SIZE = 'gcs-field-font-size';


	/**
	 * Page slug
	 *
	 * @since 0.3
	 * @var String
	 */
	 const PAGE_SLUG = 'gcs-settings-theme';

	/**
	 * Methods
	 *
	 * @since 1.0
	 * @var string
	 */
	public function __get( $prop_name )
	{
		return $this->_get_property( $prop_name );
	}

	public function __set( $prop_name, $value )
	{
		return $this->_set_property( $prop_name, $value );
	}

	public function get_branding_url( $size = 'full' )
	{
		return Utils_Helper::get_thumbnail_url( $this->_get_property( 'branding' ), $size );
	}

	private function _set_property( $prop_name, $value )
	{
		switch ( $prop_name ) {
			// BTN
			case 'BTN_BACKGROUND_COLOR' :
				update_option( self::OPTION_BTN_BACKGROUND_COLOR, $value );
				break;

			case 'BTN_BACKGROUND_COLOR_HOVER' :
				update_option( self::OPTION_BTN_BACKGROUND_COLOR_HOVER, $value );
				break;

			case 'BTN_BORDER_COLOR' :
				update_option( self::OPTION_BTN_BORDER_COLOR, $value );
				break;

			case 'BTN_BORDER_COLOR_HOVER' :
				update_option( self::OPTION_BTN_BORDER_COLOR_HOVER, $value );
				break;

			case 'BTN_BORDER_RADIUS' :
				update_option( self::OPTION_BTN_BORDER_RADIUS, $value );
				break;

			case 'BTN_BORDER_STYLE' :
				update_option( self::OPTION_BTN_BORDER_STYLE, $value );
				break;

			case 'BTN_BORDER_WIDTH' :
				update_option( self::OPTION_BTN_BORDER_WIDTH, $value );
				break;

			case 'BTN_SHADOW' :
				update_option( self::OPTION_BTN_SHADOW, $value );
				break;

			case 'BTN_FONT_SIZE' :
				update_option( self::OPTION_BTN_FONT_SIZE, $value );
				break;

			case 'BTN_FONT_STYLE' :
				update_option( self::OPTION_BTN_FONT_STYLE, $value );
				break;

			case 'BTN_FONT_WEIGHT' :
				update_option( self::OPTION_BTN_FONT_WEIGHT, $value );
				break;

			case 'BTN_PADDING' :
				update_option( self::OPTION_BTN_PADDING, $value );
				break;

			case 'BTN_POSITION' :
				update_option( self::OPTION_BTN_POSITION, $value );
				break;

			case 'BTN_TEXT_COLOR' :
				update_option( self::OPTION_BTN_TEXT_COLOR, $value );
				break;

			case 'BTN_TEXT_COLOR_HOVER' :
				update_option( self::OPTION_BTN_TEXT_COLOR_HOVER, $value );
				break;

			case 'BTN_TEXT_TRANSFORM' :
				update_option( self::OPTION_BTN_TEXT_TRANSFORM, $value );
				break;

			case 'BTN_WIDTH' :
				update_option( self::OPTION_BTN_WIDTH, $value );
				break;

			// LABEL

			case 'LABEL_FONT_SIZE' :
				update_option( self::OPTION_LABEL_FONT_SIZE, $value );
				break;

			case 'LABEL_TEXT_TRANSFORM' :
				update_option( self::OPTION_LABEL_TEXT_TRANSFORM, $value );
				break;

			// TEXT

			case 'TEXT_TEXT_TRANSFORM' :
				update_option( self::OPTION_TEXT_TEXT_TRANSFORM, $value );
				break;

			//INPUT

			case 'INPUT_BORDER_STYLE' :
				update_option( self::OPTION_INPUT_BORDER_STYLE, $value );
				break;

			case 'INPUT_SHADOW' :
				update_option( self::OPTION_INPUT_SHADOW, $value );
				break;

			case 'border' :
				update_option( self::OPTION_COLOR_BORDER, $value );
				break;

			case 'checked' :
				update_option( self::OPTION_COLOR_CHECKED, $value );
				break;

			case 'error' :
				update_option( self::OPTION_COLOR_ERROR, $value );
				break;

			case 'focus' :
				update_option( self::OPTION_COLOR_FOCUS, $value );
					break;

			case 'input' :
				update_option( self::OPTION_COLOR_INPUT, $value );
				break;

			case 'input_error' :
				update_option( self::OPTION_COLOR_INPUT_ERROR, $value );
				break;

			case 'label' :
				update_option( self::OPTION_COLOR_LABEL, $value );
				break;

			case 'placeholder' :
				update_option( self::OPTION_COLOR_PLACEHOLDER, $value );
				break;

			case 'text' :
				update_option( self::OPTION_COLOR_TEXT, $value );
				break;

			case 'success' :
				update_option( self::OPTION_COLOR_SUCCESS, $value );
				break;

			case 'border_size' :
				update_option( self::OPTION_BORDER_SIZE, $value );
				break;

			case 'input_size' :
				update_option( self::OPTION_INPUT_SIZE, $value );
					break;

			case 'textarea_size' :
				update_option( self::OPTION_TEXTAREA_SIZE, $value );
				break;

			case 'border_radius' :
				update_option( self::OPTION_BORDER_RADIUS, $value );
				break;

			case 'font_size' :
				update_option( self::OPTION_FONT_SIZE, $value );
				break;
		}
	}

	private function _get_property( $prop_name )
	{
		switch ( $prop_name ) :

			case 'BTN_BACKGROUND_COLOR' :
				if ( ! isset( $this->BTN_BACKGROUND_COLOR ) )
					$this->BTN_BACKGROUND_COLOR = get_option( self::OPTION_BTN_BACKGROUND_COLOR, '#1e73be' );
				break;

			case 'BTN_BACKGROUND_COLOR_HOVER' :
				if ( ! isset( $this->BTN_BACKGROUND_COLOR_HOVER ) )
					$this->BTN_BACKGROUND_COLOR_HOVER = get_option( self::OPTION_BTN_BACKGROUND_COLOR_HOVER, '#0066bf' );
				break;

			case 'BTN_BORDER_COLOR' :
				if ( ! isset( $this->BTN_BORDER_COLOR ) )
					$this->BTN_BORDER_COLOR = get_option( self::OPTION_BTN_BORDER_COLOR, '#fff' );
				break;

			case 'BTN_BORDER_COLOR_HOVER' :
				if ( ! isset( $this->BTN_BORDER_COLOR_HOVER ) )
					$this->BTN_BORDER_COLOR_HOVER = get_option( self::OPTION_BTN_BORDER_COLOR_HOVER, '#fff' );
				break;

			case 'BTN_BORDER_RADIUS' :
				if ( ! isset( $this->BTN_BORDER_RADIUS ) )
					$this->BTN_BORDER_RADIUS = get_option( self::OPTION_BTN_BORDER_RADIUS, '0px' );
				break;

			case 'BTN_BORDER_STYLE' :
				if ( ! isset( $this->BTN_BORDER_STYLE ) )
					$this->BTN_BORDER_STYLE = get_option( self::OPTION_BTN_BORDER_STYLE, 'none' );
				break;

			case 'BTN_BORDER_WIDTH' :
				if ( ! isset( $this->BTN_BORDER_WIDTH ) )
					$this->BTN_BORDER_WIDTH = get_option( self::OPTION_BTN_BORDER_WIDTH, '0px' );
				break;

			case 'BTN_SHADOW' :
				if ( ! isset( $this->BTN_SHADOW ) )
					$this->BTN_SHADOW = get_option( self::OPTION_BTN_SHADOW, 'none' );
				break;

			case 'BTN_FONT_SIZE' :
				if ( ! isset( $this->BTN_FONT_SIZE ) )
					$this->BTN_FONT_SIZE = get_option( self::OPTION_BTN_FONT_SIZE, 18 );
				break;

			case 'BTN_FONT_STYLE' :
				if ( ! isset( $this->BTN_FONT_STYLE ) )
					$this->BTN_FONT_STYLE = get_option( self::OPTION_BTN_FONT_STYLE, 'normal' );
				break;

			case 'BTN_FONT_WEIGHT' :
				if ( ! isset( $this->BTN_FONT_WEIGHT ) )
					$this->BTN_FONT_WEIGHT = get_option( self::OPTION_BTN_FONT_WEIGHT, '600' );
				break;

			case 'BTN_PADDING' :
				if ( ! isset( $this->BTN_PADDING ) )
					$this->BTN_PADDING = get_option( self::OPTION_BTN_PADDING, '10px 20px' );
				break;

			case 'BTN_POSITION' :
				if ( ! isset( $this->BTN_POSITION ) )
					$this->BTN_POSITION = get_option( self::OPTION_BTN_POSITION, 'right' );
				break;

			case 'BTN_TEXT_COLOR' :
				if ( ! isset( $this->BTN_TEXT_COLOR ) )
					$this->BTN_TEXT_COLOR = get_option( self::OPTION_BTN_TEXT_COLOR, '#fff' );
				break;

			case 'BTN_TEXT_COLOR_HOVER' :
				if ( ! isset( $this->BTN_TEXT_COLOR_HOVER ) )
					$this->BTN_TEXT_COLOR_HOVER = get_option( self::OPTION_BTN_TEXT_COLOR_HOVER, '#fff' );
				break;

			case 'BTN_TEXT_TRANSFORM' :
				if ( ! isset( $this->BTN_TEXT_TRANSFORM ) )
					$this->BTN_TEXT_TRANSFORM = get_option( self::OPTION_BTN_TEXT_TRANSFORM, 'initial' );
				break;

			case 'BTN_WIDTH' :
				if ( ! isset( $this->BTN_WIDTH ) )
					$this->BTN_WIDTH = get_option( self::OPTION_BTN_WIDTH, '' );
				break;

			case 'TEXT_TEXT_TRANSFORM' :
				if ( ! isset( $this->TEXT_TEXT_TRANSFORM ) )
					$this->TEXT_TEXT_TRANSFORM = get_option( self::OPTION_TEXT_TEXT_TRANSFORM, 'initial' );
				break;

			case 'LABEL_FONT_SIZE' :
				if ( ! isset( $this->LABEL_FONT_SIZE ) )
					$this->LABEL_FONT_SIZE = get_option( self::OPTION_LABEL_FONT_SIZE, 16 );
				break;

			case 'LABEL_TEXT_TRANSFORM' :
				if ( ! isset( $this->LABEL_TEXT_TRANSFORM ) )
					$this->LABEL_TEXT_TRANSFORM = get_option( self::OPTION_LABEL_TEXT_TRANSFORM, 'capitalize' );
				break;

			case 'INPUT_BORDER_STYLE' :
				if ( ! isset( $this->INPUT_BORDER_STYLE ) )
					$this->INPUT_BORDER_STYLE = get_option( self::OPTION_INPUT_BORDER_STYLE, 'solid' );
				break;

			case 'INPUT_SHADOW' :
				if ( ! isset( $this->INPUT_SHADOW ) )
					$this->INPUT_SHADOW = get_option( self::OPTION_INPUT_SHADOW, 'none' );
				break;

			case 'border' :
				if ( ! isset( $this->border ) )
					$this->border = get_option( self::OPTION_COLOR_BORDER, '#1e73be' );
				break;

			case 'checked' :
				if ( ! isset( $this->checked ) )
					$this->checked = get_option( self::OPTION_COLOR_CHECKED, '#1e73be' );
				break;

			case 'error' :
				if ( ! isset( $this->error ) )
					$this->error = get_option( self::OPTION_COLOR_ERROR, '#eb0c0c' );
				break;

			case 'focus' :
				if ( ! isset( $this->focus ) )
					$this->focus = get_option( self::OPTION_COLOR_FOCUS, '#1e73be' );
				break;

			case 'input' :
				if ( ! isset( $this->input ) )
					$this->input = get_option( self::OPTION_COLOR_INPUT, '#f5f5f5' );
				break;

			case 'input_error' :
				if ( ! isset( $this->input_error ) )
					$this->input_error = get_option( self::OPTION_COLOR_INPUT_ERROR, '#ffeeee' );
				break;

			case 'label' :
				if ( ! isset( $this->label ) )
					$this->label = get_option( self::OPTION_COLOR_LABEL, '#333' );
				break;

			case 'placeholder' :
				if ( ! isset( $this->placeholder ) )
					$this->placeholder = get_option( self::OPTION_COLOR_PLACEHOLDER, '#666666' );
				break;

			case 'text' :
				if ( ! isset( $this->text ) )
					$this->text = get_option( self::OPTION_COLOR_TEXT, '#333' );
				break;

			case 'success' :
				if ( ! isset( $this->success ) )
					$this->success = get_option( self::OPTION_COLOR_SUCCESS, '#009d47' );
				break;

			case 'border_size' :
				if ( ! isset( $this->border_size ) )
					$this->border_size = get_option( self::OPTION_BORDER_SIZE, '0px 0px 3px 0px' );
				break;

			case 'input_size' :
					if ( ! isset( $this->input_size ) )
					$this->input_size = get_option( self::OPTION_INPUT_SIZE, 45 );
				break;

			case 'textarea_size' :
				if ( ! isset( $this->textarea_size ) )
					$this->textarea_size = get_option( self::OPTION_TEXTAREA_SIZE, 200 );
				break;

			case 'border_radius' :
				if ( ! isset( $this->border_radius ) )
					$this->border_radius = get_option( self::OPTION_BORDER_RADIUS, '0px' );
				break;

			case 'font_size' :
				if ( ! isset( $this->font_size ) )
					$this->font_size = get_option( self::OPTION_FONT_SIZE, 16 );
				break;

			default :
				return false;
				break;
		endswitch;

		return $this->$prop_name;
	}
}
