<?php
namespace GCS\Custom;

// Avoid that files are directly loaded
if ( ! function_exists( 'add_action' ) ) :
	exit(0);
endif;

class Settings_View
{
	public static function render_general()
	{
		$model = new Setting();

		?>
		<div class="wrap">
			<form action="<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>" data-component="form">
				<!-- header da tabela -->
				<div class="tab">
					<span class="tablinks" onclick="openTab(event, 'tab1')">Começar</span>
					<span class="tablinks active" onclick="openTab(event, 'tab2')">Personalizar</span>
				</div>

				<!-- Items da tabela -->
				<div id="tab1" class="tabcontent" style="display: none;">
					<div class="table-items">
						<div class="bd-content">
							<h3 id="12-columns-system" class="title is-4 is-spaced bd-anchor-title">
								<span class="bd-anchor-name">
								Começando
								</span>
							</h3>

							<div class="content">
								<p>O <strong>gf-custom-style</strong> é um plugin desenvolvido para facilitar o uso do Gravity Form, com o custom-style você poderá personalizar seus formulários de forma fácil, rápida e pratica. Veja como é facil configurar o gf-custom-style:</p>
								<h4>Copie e cole a classe <code>custom-style</code> no formulário que deseja editar e salve.<h4>
								<h4 style="margin-left: 40px;">Formulários > Seu formulário > Configurações > Configurações do formulário > Nome da classe CSS </h4>
								<br>
								<p>Pronto, seu formulário agora vai receber todos os estilos do <strong>gf-custom-style</strong>. Para que todos os estilos sejam recebidos corretamente, você deverá seguir o seguinte passo:</p>
								<h4 style="margin-left: 40px;">Formulários > Configurações</h4>
								<p style="margin-left: 40px;">Marque a opção <strong>Não</strong> em : <strong>"CSS de saída"</strong></p>
								<p style="margin-left: 40px;">Marque a opção <strong>Sim</strong> em : <strong>"HTML5 da saída"</strong></p>
								<p style="margin-left: 40px;"><strong>Salvar</strong></p>
								<p>Perfeito, tudo pronto para começar a editar os estilos do formulário!</p>
							</div>

							<div class="message is-info">
								<p class="message-header">Referência</p>
								<p class="message-body">
									Os nomes das classes e o grid utilizado nesse plugin, foram baseados no framework <strong><a style="color: #00d1b2;"href="bulma.io">Bulma</a></strong>
								</p>
							</div>
						</div>

						<div class="bd-content">
							<h3 id="12-columns-system" class="title is-4 is-spaced bd-anchor-title">
								<span class="bd-anchor-name">
								Configurando os campos do formulário
								</span>
							</h3>

							<p>Cada campo do gravity deve receber uma classe, o nome dessa classe corresponde ao tamanho que o campo ocupará no formulário.</p>
							<p>O tamanho de cada campo é definido a partir de um <strong>grid</strong></p>

							<div class="content">
								<p>O grid pode ser dividido em <strong>12</strong> colunas, existem classes de tamanho para cada divisão:</p>
								<ul class="list-class">
									<li class="class-item"><code>is-2</code></li>
									<li class="class-item"><code>is-3</code></li>
									<li class="class-item"><code>is-4</code></li>
									<li class="class-item"><code>is-5</code></li>
									<li class="class-item"><code>is-6</code></li>
									<li class="class-item"><code>is-7</code></li>
									<li class="class-item"><code>is-8</code></li>
									<li class="class-item"><code>is-9</code></li>
									<li class="class-item"><code>is-10</code></li>
									<li class="class-item"><code>is-11</code></li>
								</ul>
							</div>

							<div class="message is-info">
								<p class="message-header">Convenção de nomes</p>
								<p class="message-body">
									Cada classe define o tamanho que cada campo ocupara na tela. Então, se você quiser que um campo ocupe 7 colunas de 12, use  <code>is-7</code>.</p>
							</div>

							<div class="columns">
								<div class="column is-2">
								<p class="bd-notification is-primary"><code>is-2</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-3">
								<p class="bd-notification is-primary"><code>is-3</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-4">
								<p class="bd-notification is-primary"><code>is-4</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-5">
								<p class="bd-notification is-primary"><code>is-5</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-6">
								<p class="bd-notification is-primary"><code>is-6</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-7">
								<p class="bd-notification is-primary"><code>is-7</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-8">
								<p class="bd-notification is-primary"><code>is-8</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-9">
								<p class="bd-notification is-primary"><code>is-9</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-10">
								<p class="bd-notification is-primary"><code>is-10</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
								<div class="column">
								<p class="bd-notification is-wajofij has-text-centered">1</p>
								</div>
							</div>

							<div class="columns">
								<div class="column is-11">
								<p class="bd-notification is-primary"><code>is-11</code></p>
								</div>
								<div class="column">
								<p class="bd-notification is-fojeisj has-text-centered">1</p>
								</div>
							</div>

							<p>Após escolher qual o tamanho que o campo vai ocupar, você deve copiar o nome dessa classe e colar na área reservada, que fica em :</p>
							<strong style="margin-left: 40px;">Formulários > Seu formulário > Editar > Selecione um campo > Aba Aparência > Classe CSS personalizada</strong>
							<p>Abaixo contém classes adicionais para deixar seu formulário responsivo.</p>

							<div class="message is-info">
								<p class="message-header">Detalhe</p>
								<p class="message-body">
									Caso seu campo não dê uma quebra de linha para alinha na posição inicial da tela, coloque a classe <code>clear</code> para limpar o campo.
									Essa classe faz com que o campo tenha sua posição como primeiro item da linha.
								</p>
							</div>

						</div>

						<div class="bd-content">
							<h3 id="12-columns-system" class="title is-4 is-spaced bd-anchor-title">
								<span class="bd-anchor-name">
								Deixando os campos responsivos
								</span>
							</h3>

							<div class="content">
								<p>O gride no mobile também pode ser dividido em <strong>12</strong> colunas, existem classes de tamanho para cada divisão:</p>
								<ul class="list-class">
								<li class="class-item"><code>is-1-mobile</code></li>
								<li class="class-item"><code>is-2-mobile</code></li>
								<li class="class-item"><code>is-3-mobile</code></li>
								<li class="class-item"><code>is-4-mobile</code></li>
								<li class="class-item"><code>is-5-mobile</code></li>
								<li class="class-item"><code>is-6-mobile</code></li>
								<li class="class-item"><code>is-7-mobile</code></li>
								<li class="class-item"><code>is-8-mobile</code></li>
								<li class="class-item"><code>is-9-mobile</code></li>
								<li class="class-item"><code>is-10-mobile</code></li>
								<li class="class-item"><code>is-11-mobile</code></li>
								<li class="class-item"><code>is-12-mobile</code></li>
								</ul>
							</div>

							<div class="message is-info">
								<p class="message-header">Observação</p>
								<p class="message-body">
									Tanto para <strong>desktop</strong> quanto para <strong>mobile</strong>, você tem um grid dividido em 12 colunas, porém não é aconselhado ter mais que 2 colunas no mobile.
									A usabilidade fica ruim e a experiência do usuário é comprometida.
									<br><br>Você deverá usar 2 classes, uma para <strong>desktop</strong> e outra para <strong>mobile</strong>.<br>Exemplo: <code>is-6 is-12-mobile</code>
								</p>
							</div>
						</div>

						<div class="bd-content">
							<h3 id="offset" class="title is-4 is-spaced bd-anchor-title">
								<span class="bd-anchor-name">
								Offset
								</span>
							</h3>

							<div class="content">
								<p>
									Você pode usar colunas vazias para criar espaço horizontal ao redor de um campo do formulário, você pode usar classes especiais para fazer o deslocamento, como .is-offset-x:
								</p>
							</div>

							<div class="columns is-mobile">
								<div class="column is-6 is-offset-3">
								<p class="bd-notification is-primary">
									<code class="html">is-6</code><br>
									<code class="html">is-offset-3</code>
								</p>
								</div>
							</div>

							<div class="columns is-mobile">
								<div class="column is-4 is-offset-8">
								<p class="bd-notification is-primary">
									<code class="html">is-4</code><br>
									<code class="html">is-offset-8</code>
								</p>
								</div>
							</div>

							<div class="columns is-mobile">
								<div class="column is-11 is-offset-1">
								<p class="bd-notification is-primary">
									<code class="html">is-11</code><br>
									<code class="html">is-offset-1</code>
								</p>
								</div>
							</div>
						</div>

						<div class="bd-content">
							<h3 id="offset" class="title is-4 is-spaced bd-anchor-title">
								<span class="bd-anchor-name">
								Finalizando
								</span>
							</h3>

							<div class="content">
								<p>
									Até aqui você já aprendeu como configurar o plugin e definir os tamanhos dos campos do seu formulário. Agora falta apenas você definir o estilo. <br>
								</p>
								<p>
									Na aba <strong>Personalizar</strong> você encontrará todas as opções para deixar seu formulário do seu gosto. <br>
								</p>
							</div>
						</div>
					</div>
				</div>

				<div id="tab2" class="tabcontent" style="display: block;">
					<div class="table-items">
						<!-- input -->
						<div class="accordion"><h3>Input</h3>
							<div class="icon-acordion wp-menu-image dashicons-before dashicons-arrow-right-alt2"></div>
						</div>
						<div class="panel">
							<table class="form-table custom-style-table" data-table="configurations">
								<tbody id="input-elements" class="box-element">
									<tr>
										<th scope="row">
											<label for="gcs-field-input"><?php _e( 'Color', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#f9f9f9"
												type="text" id="gcs-field-input"
												name="<?php echo Setting::OPTION_COLOR_INPUT; ?>"
												value="<?php echo esc_html( $model->input ); ?>"
											>
											<code class="code-text">background-color</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#18e0c4"
												type="text" id="gcs-field-focus"
												name="<?php echo Setting::OPTION_COLOR_FOCUS; ?>"
												value="<?php echo esc_html( $model->focus ); ?>"
											>
											<code class="code-text">color:focus</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-input-size"><?php _e( 'Heigth', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="number"
												id="gcs-field-input-size"
												name="<?php echo Setting::OPTION_INPUT_SIZE; ?>"
												value="<?php echo intval( $model->input_size ); ?>"
											>
											<br>
											<code class="code-text">input height: px</code>
										</td>

										<td id="" class="" title="">
											<input
												type="number"
												id="gcs-field-textarea-size"
												name="<?php echo Setting::OPTION_TEXTAREA_SIZE; ?>"
												value="<?php echo intval( $model->textarea_size ); ?>"
											>
											<br>
											<code class="code-text">textarea heigth: px</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-border-size"><?php _e( 'Border', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gcs-field-border-size"
												name="<?php echo Setting::OPTION_BORDER_SIZE; ?>"
												value="<?php echo esc_html( $model->border_size ); ?>"
											>
											<br>
											<code class="code-text">width: px</code>
										</td>

										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#inputborderstyle").live("change", function() {
													jQuery("#gfcs-input-border-style").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="inputborderstyle" name="name" style="width: 17px;height: 25px;">
												<option value="dashed">dashed</option>
												<option value="dotted">dotted</option>
												<option value="double">double</option>
												<option value="groove">groove</option>
												<option value="hidden">hidden</option>
												<option value="inherit">inherit</option>
												<option value="initial">initial</option>
												<option value="inset">inset</option>
												<option value="none">none</option>
												<option value="outset">outset</option>
												<option value="ridge">ridge</option>
												<option value="solid">solid</option>
												<option value="unset">unset</option>
											</select>
											<input type="text" id="gfcs-input-border-style" name="<?php echo Setting::OPTION_INPUT_BORDER_STYLE; ?>" value="<?php echo esc_html( $model->INPUT_BORDER_STYLE ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">style</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#7f6fce"
												type="text" id="gcs-field-border"
												name="<?php echo Setting::OPTION_COLOR_BORDER; ?>"
												value="<?php echo esc_html( $model->border ); ?>"
											>
											<code class="code-text">color</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-border-radius"><?php _e( 'Border Radius', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gcs-field-border-radius"
												name="<?php echo Setting::OPTION_BORDER_RADIUS; ?>"
												value="<?php echo esc_html( $model->border_radius ); ?>"
											>
											<br>
											<code class="code-text">border-radius: px | %</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-input-shadow"><?php _e( 'Box Shadow', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gfcs-input-shadow"
												style="width: 200px!important;"
												name="<?php echo Setting::OPTION_INPUT_SHADOW; ?>"
												value="<?php echo esc_html( $model->INPUT_SHADOW ); ?>"
											>
											<br>
											<code class="code-text">box-shadow: px px px px #hexaColor</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-checked"><?php _e( 'Checkbox|Radio|Default', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#7f6fce"
												type="text" id="gcs-field-checked"
												name="<?php echo Setting::OPTION_COLOR_CHECKED; ?>"
												value="<?php echo esc_html( $model->checked ); ?>"
											>
											<code class="code-text">color</code>
										</td>
									</tr>
								</tbody>
							</table>
						</div>

						<!-- label -->
						<div class="accordion"><h3>Title/Label</h3>
							<div class="icon-acordion wp-menu-image dashicons-before dashicons-arrow-right-alt2"></div>
						</div>
						<div class="panel">
							<table class="form-table custom-style-table" data-table="configurations">
								<tbody id="label-elements" class="box-element">
									<!-- <tr>
										<th>
											<h2>Title/Label</h2>
										</th>
									</tr> -->

									<tr>
										<th scope="row">
											<label for="gcs-field-label"><?php _e( 'Title Color', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#525252"
												type="text" id="gcs-field-label"
												name="<?php echo Setting::OPTION_COLOR_LABEL; ?>"
												value="<?php echo esc_html( $model->label ); ?>"
											>
											<code class="code-text">color</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-label-font-size"><?php _e( 'Font Size', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="number"
												id="gfcs-label-font-size"
												name="<?php echo Setting::OPTION_LABEL_FONT_SIZE; ?>"
												value="<?php echo intval( $model->LABEL_FONT_SIZE ); ?>"
											>
											<br>
											<code class="code-text">font-size: px</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-label-text-transform"><?php _e( 'Text Transform', App::PLUGIN_SLUG ); ?>
										</th>
										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#labeltexttransform").live("change", function() {
													jQuery("#gfcs-label-text-transform").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="labeltexttransform" name="name" style="width: 17px;height: 25px;">
												<option value="captalize">captalize</option>
												<option value="inherit">inherit</option>
												<option value="initial">initial</option>
												<option value="lowercase">lowercase</option>
												<option value="none">none</option>
												<option value="uppercase">uppercase</option>
											</select>
											<input type="text" id="gfcs-label-text-transform" name="<?php echo Setting::OPTION_LABEL_TEXT_TRANSFORM; ?>" value="<?php echo esc_html( $model->LABEL_TEXT_TRANSFORM ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">text-transform</code>
										</td>
									</tr>
								</tbody>
							</table>
						</div>

						<!-- text -->
						<div class="accordion"><h3>Text</h3>
							<div class="icon-acordion wp-menu-image dashicons-before dashicons-arrow-right-alt2"></div>
						</div>
						<div class="panel">
							<table class="form-table custom-style-table" data-table="configurations">
								<tbody id="label-elements" class="box-element">
									<!-- <tr>
										<th>
											<h2>Text</h2>
										</th>
									</tr> -->
									<tr>
										<th scope="row">
											<label for="gcs-field-text"><?php _e( 'Text Color', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#595959"
												type="text" id="gcs-field-text"
												name="<?php echo Setting::OPTION_COLOR_TEXT; ?>"
												value="<?php echo esc_html( $model->text ); ?>"
											>
											<code class="code-text">color</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#666666"
												type="text" id="gcs-field-placeholder"
												name="<?php echo Setting::OPTION_COLOR_PLACEHOLDER; ?>"
												value="<?php echo esc_html( $model->placeholder ); ?>"
											>
											<code class="code-text">color:placeholder</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-font-size"><?php _e( 'Font Size', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="number" id="gcs-field-font-size"
												name="<?php echo Setting::OPTION_FONT_SIZE; ?>"
												value="<?php echo intval( $model->font_size ); ?>"
											>
											<br>
											<code class="code-text">font-size: px</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-text-text-transform"><?php _e( 'Text Transform', App::PLUGIN_SLUG ); ?>
										</th>
										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#texttexttransform").live("change", function() {
													jQuery("#gfcs-text-text-transform").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="texttexttransform" name="name" style="width: 17px;height: 25px;">
												<option value="captalize">captalize</option>
												<option value="inherit">inherit</option>
												<option value="initial">initial</option>
												<option value="lowercase">lowercase</option>
												<option value="none">none</option>
												<option value="uppercase">uppercase</option>
											</select>
											<input type="text" id="gfcs-text-text-transform" name="<?php echo Setting::OPTION_TEXT_TEXT_TRANSFORM; ?>" value="<?php echo esc_html( $model->TEXT_TEXT_TRANSFORM ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">text-transform</code>
										</td>
									</tr>
								</tbody>
							</table>
						</div>

						<!-- button -->
						<div class="accordion"><h3>Button</h3>
							<div class="icon-acordion wp-menu-image dashicons-before dashicons-arrow-right-alt2"></div>
						</div>
						<div class="panel">
							<table class="form-table custom-style-table" data-table="configurations">
								<tbody id="label-elements" class="box-element">
									<tr>
										<th scope="row">
											<label for="gfcs-btn-background-color"><?php _e( 'Background Color', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#7f6fce"
												type="text" id="gfcs-btn-background-color"
												name="<?php echo Setting::OPTION_BTN_BACKGROUND_COLOR; ?>"
												value="<?php echo esc_html( $model->BTN_BACKGROUND_COLOR ); ?>"
											>
											<code class="code-text">background-color</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#ededed"
												type="text" id="gfcs-btn-background-color-hover"
												name="<?php echo Setting::OPTION_BTN_BACKGROUND_COLOR_HOVER; ?>"
												value="<?php echo esc_html( $model->BTN_BACKGROUND_COLOR_HOVER ); ?>"
											>
											<code class="code-text">background-color:hover</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-border-width"><?php _e( 'Border', App::PLUGIN_SLUG ); ?></label>
										</th>

										<td id="" class="" title="">
											<input
												type="text"
												id="gfcs-btn-border-width"
												name="<?php echo Setting::OPTION_BTN_BORDER_WIDTH; ?>"
												value="<?php echo esc_html( $model->BTN_BORDER_WIDTH ); ?>"
											>
											<br>
											<code class="code-text">border-width: px</code>
										</td>

										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#borderstyle").live("change", function() {
													jQuery("#gfcs-btn-border-style").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="borderstyle" name="name" style="width: 17px;height: 25px;">
												<option value="dashed">dashed</option>
												<option value="dotted">dotted</option>
												<option value="double">double</option>
												<option value="groove">groove</option>
												<option value="hidden">hidden</option>
												<option value="inherit">inherit</option>
												<option value="initial">initial</option>
												<option value="inset">inset</option>
												<option value="none">none</option>
												<option value="outset">outset</option>
												<option value="ridge">ridge</option>
												<option value="solid">solid</option>
												<option value="unset">unset</option>
											</select>

											<input type="text" id="gfcs-btn-border-style" name="<?php echo Setting::OPTION_BTN_BORDER_STYLE; ?>" value="<?php echo esc_html( $model->BTN_BORDER_STYLE ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">border-style</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#ffffff"
												type="text" id="gfcs-btn-border-color"
												name="<?php echo Setting::OPTION_BTN_BORDER_COLOR; ?>"
												value="<?php echo esc_html( $model->BTN_BORDER_COLOR ); ?>"
											>
											<code class="code-text">border-color</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#ededed"
												type="text" id="gfcs-btn-border-color-hover"
												name="<?php echo Setting::OPTION_BTN_BORDER_COLOR_HOVER; ?>"
												value="<?php echo esc_html( $model->BTN_BORDER_COLOR_HOVER ); ?>"
											>
											<code class="code-text">border-color:hover</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-border-radius"><?php _e( 'Border Radius', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gfcs-btn-border-radius"
												name="<?php echo Setting::OPTION_BTN_BORDER_RADIUS; ?>"
												value="<?php echo esc_html( $model->BTN_BORDER_RADIUS ); ?>"
											>
											<br>
											<code class="code-text">border-radius: px | %</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-shadow"><?php _e( 'Box Shadow', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gfcs-btn-shadow"
												style="width: 200px!important;"
												name="<?php echo Setting::OPTION_BTN_SHADOW; ?>"
												value="<?php echo esc_html( $model->BTN_SHADOW ); ?>"
											>
											<br>
											<code class="code-text">box-shadow: px px px px #hexaColor</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-text-color"><?php _e( 'Color Text', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#ffffff"
												type="text" id="gfcs-btn-text-color"
												name="<?php echo Setting::OPTION_BTN_TEXT_COLOR; ?>"
												value="<?php echo esc_html( $model->BTN_TEXT_COLOR ); ?>"
											>
											<code class="code-text">color</code>
										</td>

										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#7f6fce"
												type="text" id="gfcs-btn-text-color-hover"
												name="<?php echo Setting::OPTION_BTN_TEXT_COLOR_HOVER; ?>"
												value="<?php echo esc_html( $model->BTN_TEXT_COLOR_HOVER ); ?>"
											>
											<code class="code-text">color:hover</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-font-size"><?php _e( 'Font', App::PLUGIN_SLUG ); ?>
										</th>
										<td id="" class="" title="">
											<input
												type="number"
												id="gfcs-btn-font-size"
												name="<?php echo Setting::OPTION_BTN_FONT_SIZE; ?>"
												value="<?php echo intval( $model->BTN_FONT_SIZE ); ?>"
											>
											<br>
											<code class="code-text">font-size: px</code>
										</td>

										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#fontstyle").live("change", function() {
													jQuery("#gfcs-btn-font-style").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="fontstyle" name="name" style="width: 17px;height: 25px;">
												<option value="initial">initial</option>
												<option value="italic">italic</option>
												<option value="normal">normal</option>
												<option value="oblique">oblique</option>
												<option value="unset">unset</option>
											</select>
											<input type="text" id="gfcs-btn-font-style" name="<?php echo Setting::OPTION_BTN_FONT_STYLE; ?>" value="<?php echo esc_html( $model->BTN_FONT_STYLE ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">font-style</code>
										</td>

										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#fontweight").live("change", function() {
													jQuery("#gfcs-btn-font-weight").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="fontweight" name="name" style="width: 17px;height: 25px;">
												<option value="100">100</option>
												<option value="200">200</option>
												<option value="300">300</option>
												<option value="400">400</option>
												<option value="500">500</option>
												<option value="600">600</option>
												<option value="700">700</option>
												<option value="800">800</option>
												<option value="900">900</option>
												<option value="bold">bold</option>
												<option value="bolder">bolder</option>
												<option value="initial">initial</option>
												<option value="lighter">lighter</option>

											</select>
											<input type="text" id="gfcs-btn-font-weight" name="<?php echo Setting::OPTION_BTN_FONT_WEIGHT; ?>" value="<?php echo esc_html( $model->BTN_FONT_WEIGHT ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">font-weight</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-padding"><?php _e( 'Padding', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gfcs-btn-padding"
												name="<?php echo Setting::OPTION_BTN_PADDING; ?>"
												value="<?php echo esc_html( $model->BTN_PADDING ); ?>"
											>
											<br>
											<code class="code-text">padding: px </code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-position"><?php _e( 'Position', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#name").live("change", function() {
													jQuery("#gfcs-btn-position").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="name" name="name" style="width: 17px;height: 25px;">
												<option value="left">Left</option>
												<option value="right">Right</option>
												<option value="center">Center</option>
											</select>
											<input type="text" id="gfcs-btn-position" name="<?php echo Setting::OPTION_BTN_POSITION; ?>" value="<?php echo esc_html( $model->BTN_POSITION ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">float</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-text-transform"><?php _e( 'Text Transform', App::PLUGIN_SLUG ); ?>
										</th>
										<td id="" class="" title="">
											<script type="text/javascript">
												jQuery("#texttransform").live("change", function() {
													jQuery("#gfcs-btn-text-transform").val(jQuery(this).find("option:selected").attr("value"));
												});
											</script>

											<select id="texttransform" name="name" style="width: 17px;height: 25px;">
												<option value="captalize">captalize</option>
												<option value="inherit">inherit</option>
												<option value="initial">initial</option>
												<option value="lowercase">lowercase</option>
												<option value="none">none</option>
												<option value="uppercase">uppercase</option>
											</select>
											<input type="text" id="gfcs-btn-text-transform" name="<?php echo Setting::OPTION_BTN_TEXT_TRANSFORM; ?>" value="<?php echo esc_html( $model->BTN_TEXT_TRANSFORM ); ?>" readonly="readonly" style="float: left; width: 55px;">
											<br>
											<code class="code-text">text-transform</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gfcs-btn-width"><?php _e( 'Width', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												type="text"
												id="gfcs-btn-width"
												name="<?php echo Setting::OPTION_BTN_WIDTH; ?>"
												value="<?php echo esc_html( $model->BTN_WIDTH ); ?>"
											>
											<br>
											<code class="code-text">width: px | %</code>
										</td>
									</tr>
								</tbody>
							</table>
						</div>


						<!-- Validation -->
						<div class="accordion"><h3>Validation</h3>
							<div class="icon-acordion wp-menu-image dashicons-before dashicons-arrow-right-alt2"></div>
						</div>
						<div class="panel">
							<table class="form-table custom-style-table" data-table="configurations">
								<tbody id="label-elements" class="box-element">
									<!-- <tr>
										<th>
											<h2>Validation</h2>
										</th>
									</tr> -->
									<tr>
										<th scope="row">
											<label for="gcs-field-success"><?php _e( 'Success Message Text Color', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#009d47"
												type="text" id="gcs-field-success"
												name="<?php echo Setting::OPTION_COLOR_SUCCESS; ?>"
												value="<?php echo esc_html( $model->success ); ?>"
											>
											<code class="code-text">color</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-error"><?php _e( 'Error Message Text Color', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#eb0c0c"
												type="text" id="gcs-field-error"
												name="<?php echo Setting::OPTION_COLOR_ERROR; ?>"
												value="<?php echo esc_html( $model->error ); ?>"
											>
											<code class="code-text">color</code>
										</td>
									</tr>

									<tr>
										<th scope="row">
											<label for="gcs-field-input_error"><?php _e( 'Input Background Color With Error', App::PLUGIN_SLUG ); ?></label>
										</th>
										<td id="" class="" title="">
											<input
												data-component="color-picker"
												data-default-color="#ffeeee"
												type="text" id="gcs-field-input-error"
												name="<?php echo Setting::OPTION_COLOR_INPUT_ERROR; ?>"
												value="<?php echo esc_html( $model->input_error ); ?>"
											>
											<code class="code-text">background-color</code>
										</td>
									</tr>
								</tbody>
							</table>
						</div>
					</div>
				</div>

				<script>
					function openTab(evt, tabName) {
						var i, tabcontent, tablinks;
						tabcontent = document.getElementsByClassName("tabcontent");
						for (i = 0; i < tabcontent.length; i++) {
							tabcontent[i].style.display = "none";
						}
						tablinks = document.getElementsByClassName("tablinks");
						for (i = 0; i < tablinks.length; i++) {
							tablinks[i].className = tablinks[i].className.replace(" active", "");
						}
						document.getElementById(tabName).style.display = "block";
						evt.currentTarget.className += " active";
					}
				</script>

				<script>
					var acc = document.getElementsByClassName("accordion");
					var i;

					for (i = 0; i < acc.length; i++) {
						acc[i].addEventListener("click", function() {
							this.classList.toggle("active");
							var panel = this.nextElementSibling;
							if (panel.style.display === "block") {
								panel.style.display = "none";
							} else {
								panel.style.display = "block";
							}
						});
					}
				</script>

				<p class="submit">
					<?php
						wp_nonce_field(
							Setting::NONCE_GENERAL_ACTION,
							Setting::NONCE_GENERAL_NAME
						);
					?>

					<input type="hidden" name="action" value="general_save_settings">
					<input type="submit" class="button button-primary" value="<?php echo esc_attr_e( 'Save', App::PLUGIN_SLUG ); ?>" data-element="submit">
				</p>
			</form>
		</div>
		<?php
	}

	public static function render_config_css_inline()
	{
		$model = new Setting();
		$BTN_BACKGROUND_COLOR		= htmlentities( $model->BTN_BACKGROUND_COLOR );
		$BTN_BACKGROUND_COLOR_HOVER	= htmlentities( $model->BTN_BACKGROUND_COLOR_HOVER );
		$BTN_BORDER_COLOR			= htmlentities( $model->BTN_BORDER_COLOR );
		$BTN_BORDER_COLOR_HOVER		= htmlentities( $model->BTN_BORDER_COLOR_HOVER );
		$BTN_BORDER_RADIUS			= htmlentities( $model->BTN_BORDER_RADIUS );
		$BTN_BORDER_STYLE			= htmlentities( $model->BTN_BORDER_STYLE );
		$BTN_BORDER_WIDTH			= htmlentities( $model->BTN_BORDER_WIDTH );
		$BTN_SHADOW					= htmlentities( $model->BTN_SHADOW );
		$BTN_FONT_SIZE				= htmlentities( $model->BTN_FONT_SIZE );
		$BTN_FONT_STYLE				= htmlentities( $model->BTN_FONT_STYLE );
		$BTN_FONT_WEIGHT			= htmlentities( $model->BTN_FONT_WEIGHT );
		$BTN_PADDING				= htmlentities( $model->BTN_PADDING );
		$BTN_POSITION				= htmlentities( $model->BTN_POSITION );
		$BTN_TEXT_COLOR				= htmlentities( $model->BTN_TEXT_COLOR );
		$BTN_TEXT_COLOR_HOVER		= htmlentities( $model->BTN_TEXT_COLOR_HOVER );
		$BTN_TEXT_TRANSFORM			= htmlentities( $model->BTN_TEXT_TRANSFORM );
		$BTN_WIDTH					= htmlentities( $model->BTN_WIDTH );

		$LABEL_FONT_SIZE			= htmlentities( $model->LABEL_FONT_SIZE );
		$LABEL_TEXT_TRANSFORM		= htmlentities( $model->LABEL_TEXT_TRANSFORM );

		$TEXT_TEXT_TRANSFORM		= htmlentities( $model->TEXT_TEXT_TRANSFORM );
		$INPUT_BORDER_STYLE			= htmlentities( $model->INPUT_BORDER_STYLE );
		$INPUT_SHADOW				= htmlentities( $model->INPUT_SHADOW );
		$border						= htmlentities( $model->border );
		$checked					= htmlentities( $model->checked );
		$error						= htmlentities( $model->error );
		$focus						= htmlentities( $model->focus );
		$input						= htmlentities( $model->input );
		$input_error				= htmlentities( $model->input_error );
		$label						= htmlentities( $model->label );
		$placeholder				= htmlentities( $model->placeholder );
		$text						= htmlentities( $model->text );
		$success					= htmlentities( $model->success );
		$border_size				= htmlentities( $model->border_size );
		$input_size					= htmlentities( $model->input_size );
		$textarea_size				= htmlentities( $model->textarea_size );
		$border_radius				= htmlentities( $model->border_radius );
		$font_size					= htmlentities( $model->font_size );
		$border_style				= htmlentities( $model->border_radius_btn );


		echo "
		<style type=\"text/css\">
			.custom-style .gfield_radio li label,
			.custom-style .gfield_checkbox li label {
				color: {$text} !important;
				text-transform: {$TEXT_TEXT_TRANSFORM}!important;
			}

			.custom-style .gfield .gfield_label {
				color: {$label}!important;
				font-size: {$LABEL_FONT_SIZE}px!important;
				text-transform:{$LABEL_TEXT_TRANSFORM}!important;
			}

			.custom-style input[type='checkbox']:after {
				background-color: {$input} !important;
			}

			.custom-style input[type='checkbox']:checked:after {
				background-color: {$checked} !important;
			}

			.custom-style input[type='radio']:after {
				background-color: {$input} !important;
			}

			.custom-style input[type='radio']:checked:after {
				background-color: {$checked} !important;
			}

			.custom-style .gfield input[type='radio'],
			.custom-style .gfield input[type='checkbox'] {
				border-color: {$border} !important;
				border-width: {$border_size}!important;
			}

			.gfield select,
			.gfield textarea,
			.gfield input {
				background: {$input} !important;
				border-color: {$border}!important;
				border-radius: {$border_radius} !important;
				border-style: {$INPUT_BORDER_STYLE}!important;
				border-width: {$border_size}!important;
				box-shadow: {$INPUT_SHADOW};
				color: {$text} !important;
				font-size: {$font_size}px !important;
				text-transform: {$TEXT_TEXT_TRANSFORM}!important;
			}

			.gfield select:focus,
			.gfield textarea:focus,
			.gfield input:focus {
				box-shadow: 0px 0px 4px -1px {$focus}!important;
			}

			.gfield select,
			.gfield input {
				height: {$input_size}px !important;
			}

			.gfield textarea {
				height: {$textarea_size}px !important;
			}

			.custom-style .gform_button {
				background: {$BTN_BACKGROUND_COLOR} !important;
				border-radius: {$BTN_BORDER_RADIUS} !important;
				border-color: {$BTN_BORDER_COLOR} !important;
				border-style: {$BTN_BORDER_STYLE} !important;
				border-width: {$BTN_BORDER_WIDTH} !important;
				box-shadow: {$BTN_SHADOW};
				color: {$BTN_TEXT_COLOR} !important;
				font-size: {$BTN_FONT_SIZE}px !important;
				font-style: {$BTN_FONT_STYLE} !important;
				font-weight: {$BTN_FONT_WEIGHT} !important;
				padding: {$BTN_PADDING} !important;
				text-transform: {$BTN_TEXT_TRANSFORM} !important;
				width: {$BTN_WIDTH}!important;
			}

			.custom-style .gform_button:hover {
				background: {$BTN_BACKGROUND_COLOR_HOVER} !important;
				color: {$BTN_TEXT_COLOR_HOVER} !important;
				border-color: {$BTN_BORDER_COLOR_HOVER} !important;
			}

			.custom-style .gform_footer {
				float: {$BTN_POSITION}!important;
			}

			.gform_wrapper .gfield_error input,
			.gform_wrapper .gfield_error select,
			.gform_wrapper .gfield_error textarea {
				background: {$input_error} !important;
			}

			.validation_error {
				background: {$error} !important;
				border-radius: {$border_radius} !important;
			}

			.gfield_description.validation_message {
				color: {$error} !important;
			}

			.gform_confirmation_wrapper .gform_confirmation_message {
				background: {$success} !important;
				border-radius: {$border_radius} !important;
				font-size: {$font_size}px !important;
			}

			.custom-style .gfield_error input[type='radio']:after,
			.custom-style .gfield_error input[type='checkbox']:after {
				background: {$error} !important;
			}

			.custom-style .gfield_error input[type='radio']:checked:after,
			.custom-style .gfield_error input[type='checkbox']:checked:after {
				background: {$checked} !important;
			}

			.custom-style ::-webkit-input-placeholder {
				color: {$placeholder} !important;
			}

			.custom-style ::-moz-placeholder {
				color: {$placeholder} !important;
			}

			.custom-style :-ms-input-placeholder {
				color: {$placeholder} !important;
			}

			.custom-style :-moz-placeholder {
				color: {$placeholder} !important;
			}

			.custom-style .gform_wrapper .gf_progressbar {
				background: {$checked} !important;
			}

			.custom-style ::-webkit-input-placeholder {
				color: {$placeholder} !important;
			}

			.ui-datepicker {
				background: {$input} !important;
			}

			.ui-datepicker-header {
				background: {$checked} !important;
			}

			.ui-datepicker-calendar th span {
				color: {$checked} !important;
			}

			.ui-datepicker-calendar td:hover {
				background: {$input} !important;
			}
		</style>
		";
	}
}